#include "TranscodeHandler.hpp"

#include <fstream>
#include <stdio.h>
#include <iostream>

#include "nmm/utils/utils.hpp"

namespace NMM{
  TranscodeHandler::TranscodeHandler(TranscoderWebInterface *trans)
    : WebRequestHandler("transcode"),
      transcoder(trans)
  {}
  TranscodeHandler::~TranscodeHandler(){}
  
  void TranscodeHandler::doGet (WebServerRequest *pRequest, WebServerResponse *pResponse){
//     cerr << "Method  : " << pRequest->getMethod() << endl;
//     cerr << "Protocol: " << pRequest->getProtocol() << endl;
//     cerr << "URI     : " << pRequest->getRequestURI() << endl;
//     cerr << "Query   : " << pRequest->getQueryString() << endl;
//     cerr << "RemAddr : " << pRequest->getRemoteAddress() << endl;

    string requestOption = pRequest->getQueryString();
    requestOption = requestOption.substr(0,requestOption.find_first_of('='));

    pResponse->write("<html><head><title>Transcoder Webinterface</title>");
    ifstream f((getNMMResourceDir() + "/mmbox/webhandler/transcode.css").c_str());
    char line[1000];
    if(f.fail()){
    }else{
      while(!f.eof()){
        f.getline(line, 1000);
        pResponse->write(string(line));
      }
      f.close(); 
    }
    pResponse->write("</head><body><h1>Transcoder Webinterface</h1><br>");

    pResponse->write("<table id='all'><tr><th>Transcoding Groups</th><th>Transcoding Jobs</th></tr>");

    if (requestOption.empty()) {
      list<pair<int,string> > group_list = transcoder->getTranscodingGroups();
      for (list<pair<int,string> >::iterator iter = group_list.begin(); iter!=group_list.end(); iter++) {
        pResponse->write("<tr><td><a href='/transcode?JobList="+itoa((*iter).first)+"'>"+
                         ((*iter).second)+"</a></td><td></td></tr>");
      }
    } else if (requestOption == "JobList" || requestOption == "Job") {
      string requestParams = pRequest->getQueryString().substr(pRequest->getQueryString().find_first_of('=')+1);
      int group = atoi(requestParams.substr(0,requestParams.find_first_of(":")).c_str());
      int job = -1;
      if (requestOption=="Job") 
        job = atoi(requestParams.substr(requestParams.find_first_of(":")+1).c_str());
      list<string> job_list = transcoder->getTranscodingJobs(group);
      list<pair<int,string> > group_list = transcoder->getTranscodingGroups();
      int group_size = group_list.size();
      int job_size = job_list.size();
      int maxsize = max(job_size,group_size);
      
      //Build group-list
      for (int i=0;i<maxsize;i++) {
        if (i<group_size) {
          pair<int,string> pair = group_list.front();
          if (group == pair.first) {
            pResponse->write("<tr id='color2'><td id='filled'>");
          }
          else {
            pResponse->write("<tr id='color2'><td>");
          }
          pResponse->write("<a href='/transcode?JobList="+itoa(pair.first)+"'>"+(pair.second)+"</a></td>");
          group_list.pop_front();
        } else {
          pResponse->write("<tr id='color2'><td></td>");
        }
        if (i<job_size) {
          string pos = (job_list.front()).substr(0,(job_list.front()).find_first_of(':'));
          string name = (job_list.front()).substr((job_list.front()).find_first_of(':')+1);
          job_list.pop_front();
          if (i==job) pResponse->write("<td id='filled'>"); else pResponse->write("<td>");
          pResponse->write("<a href='/transcode?Job="+itoa(group)+":"+pos+"'>"+name+"</a></td></tr>");
        } else {
          pResponse->write("<td></td></tr>");
        }
      }
      pResponse->write("</table><br>");

      if (requestOption == "JobList") {
        //Build group-information table
        list<string> group_info = transcoder->getGroupInformation(group);
        pResponse->write("<table id='all'><th>Transcoding-Group Information</th></tr>");
        for (list<string>::iterator iter = group_info.begin(); iter!=group_info.end(); iter++) {
          pResponse->write("<tr><td>"+(*iter)+"</td></tr>");
        }
      } else if (requestOption == "Job") {
        //Build Job-information table
        pResponse->write("<table id='all'><th>Transcoding-Job Information</th></tr>");
        list<string> job_info = transcoder->getJobInformation(group,job);
        for (list<string>::iterator iter = job_info.begin(); iter!=job_info.end(); iter++) {
          pResponse->write("<tr><td>"+(*iter)+"</td></tr>");
        }
      }
    }
    pResponse->write("</table></body></html>");
  }

  void TranscodeHandler::doPost(WebServerRequest *, WebServerResponse *){
  }
}
