/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Christian Gerstner <gerstner@graphics.cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef _NMM_VCORE_CONTAINERWIDGET_HPP_
#define _NMM_VCORE_CONTAINERWIDGET_HPP_ _NMM_VCORE_CONTAINERWIDGET_HPP_


#include <qwidget.h>
#include <qlayout.h>
#include <qtxembed.hpp>

namespace NMM {
    class NMMApplication;
}

class ContainerWidget : public QWidget
{
    Q_OBJECT
private:
    QtXEmbedContainer *container;
    QVBoxLayout *layout;
    
public:
    /**
     * The main widget for the application holding all needed
     * buttons, editlines, sliders, switchboxes, ...
     */
  ContainerWidget(QWidget *parent = 0, const char *name = "ContainerWidget", WFlags f = 0);
  
  ~ContainerWidget();
  
  void embedWindow(const int wid);
  void discardWindow();
};
#endif //_NMM_VCORE_CONTAINERWIDGET_HPP_
   
