#!/bin/sh

# NMM - Network-Integrated Multimedia Environment

# Copyright (C) 2002 Network-Multimedia Workgroup, 
#                    Computer Graphics Lab,
#                    Saarland University, Germany
#                    http://www.networkmultimedia.org

# Maintainer:        

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 
# USA.


# this function tries to run a specified program and prints out a
# message, if it fails (e.g. the program does not exists in the path)
run_autotool() {
    program=$1
    cmd="$@"
    echo "$cmd"
    $cmd || (echo "Cannot run autotool \"$program\". Please install and try again!"; exit 1)
}

# the order of the autotools-chain is important!
run_autotool aclocal
run_autotool autoheader
# the "--automake" switch informs libtoolize, that it runs on a
# project which uses automake
run_autotool libtoolize --automake
# the "--add-missing" switch informs automake to symlink missing files
# (e.g. the GPL file or the "missing" tool)
# if you don't care about disk space, you can additionally specify the
# "--copy" switch which copies the files instead of symlinking them!
run_autotool automake --add-missing
run_autotool autoconf
