/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#include <iostream>
#include "nmm/misc/lcd/LCDWriter.hpp"

using namespace NMM;

int main(int, char **)
{
  // The driver for the lcd-display has to be loaded!!!

  LCDWriter *lcdWriter = new LCDWriter();
  // init is important, otherwise it won't work
  if (lcdWriter->init() == FAILURE) {
    cerr << "lcdWriter init failed!" << endl;
    exit(0);
  }

  // set some example text
  lcdWriter->setText(0,"Hallo Welt C++");
  lcdWriter->setText(1,"2.Zeile");
  sleep (1);

  // Date/Time and Progress-Bar
  for (int i=0; i<101; i++)
  {
    lcdWriter->setDateTime(0);
    lcdWriter->setProgressBar(1,i);
    usleep(50000);
  }
  sleep(1);

  // Clearing line 1
  lcdWriter->clearLine(1);
  sleep(1);

  // Moving Character
  for (int i=0; i<20; i++)
  {
    lcdWriter->setChar(i-1, 1, ' ');
    lcdWriter->setChar(i,1,'A');
    usleep(100000);
  }
  for (int i=20; i>-1; i--)
  {
    lcdWriter->setChar(i+1, 1, ' ');
    lcdWriter->setChar(i,1,'A');
    usleep(100000);
  }
  sleep (1);

  // Clearing line - this is not really necessary, just for demonstration
  lcdWriter->clearLine(0);
  sleep(1);

  // Scrolling...
  unsigned int i  = 0;
  int up = 1;
  const char *line0 = "Hallo Welt, dies ist ein Scroll-Test, und dieses Mal ein etwas laengerer...";
  for (int j=1; j<100; j++)
  {
    lcdWriter->setText(0,line0+i);
    if (up) i++; else i--;
    if (i==(strlen(line0)-LINE_LENGTH)) up=0;
    if (i==0)  up=1;
    usleep(200000);
  }

  sleep (1);
  lcdWriter->clear();
}
