/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Marco Lohse <mlohse@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#include "BaseExceptions.hpp"
#include "nmm/base/serialize/ValueFactory.hpp"

namespace NMM
{

  void DeviceNotFoundException::registerAttributes() {
    insertArgument(&__device);
  }
  
  void WrongDeviceException::registerAttributes() {
    insertArgument(&__device);
  }
  
  TConstructor<Exception>                         __nmm__default_exception("Exception", "NMM");
  TConstructor<StateTransitionFailedException>    __nmm__stf_exception("StateTransitionFailedException", "NMM");
  TConstructor<IllegalStateTransitionException>   __nmm__ist_exception("IllegalStateTransitionException", "NMM");
  TConstructor<IllegalStateException>             __nmm__is_exception("IllegalStateException", "NMM");
  TConstructor<BindingException>                  __nmm__binding_exception("BindingException", "NMM");
  TConstructor<UnbindingException>                __nmm__unbinding_exception("UnbindingException", "NMM");
  TConstructor<UnexpectedException>               __nmm__unexpeceted_exception("UnexpectedException", "NMM");
  TConstructor<UnknownEventException>             __nmm__unknown_event_exception("UnknownEventException", "NMM");
  TConstructor<UnsuccessfulRequiredCallException> __nmm__unsuccessful_required_call_exception("UnsuccessfulRequiredCallException", "NMM");
  TConstructor<DeviceNotFoundException>           __nmm__device_not_found_exception("DeviceNotFoundException", "NMM");
  TConstructor<InterfaceNotFoundException>        __nmm__interface_not_found_exception("InterfcaceNotFoundException", "NMM");
  TConstructor<InvalidTypeException>              __nmm__invalid_type_exception("InvalidTypeException", "NMM");
  TConstructor<WrongDeviceException>              __nmm__wrong_device_exception("WrongDeviceException", "NMM");
}
