/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        NMM work group,
 *                    http://www.networkmultimedia.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_FUNCTION_HPP
#define _NMM_FUNCTION_HPP

#include "definition.hpp"

namespace NMM 
{
  /**
     This header-files defines some usefull functions
     which are needed by some classes.
  **/

  /**
     This function converts a given int argument to a string.
     \param int pValue: a int value.
     \return string: contains the value of the int as a string.
  **/
  string intToString(int pValue);

  string getGUID();

 // string getHostname();

  //string_list transformNodeConnectorList(node_connector_list & list);

  ostream & operator << (ostream &os, const string_list & param);

  //ostream & operator << (ostream &os, const Negotiation_Result &param);

  //ostream & operator << (ostream &os, const negotiation_result_list &param);

  //ostream & operator << (ostream &os, const negotiation_result_list &param);

//  ostream & operator << (ostream &os, const connection_object_list &param);
//
//  ostream & operator << (ostream &os, const connection_object_multi_list &param);

  ostream & operator << (ostream &os, const parameter_list &param);

  ostream & operator << (ostream &os, const format_list &param);
  
//  ostream & operator << (ostream &os, const node_connector_list & param);

  ostream & operator << (ostream &os, const edge_list & param);
  
//  ostream & operator << (ostream &os, const DependentTreeResultItem & param);

//  ostream & operator << (ostream &os, const DependentTreeResult & param);

//  ostream & operator << (ostream &os, const dependent_tree_result_list & param);
}

#endif
