/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef _NMM_RANGE_HPP_
#define _NMM_RANGE_HPP_

#include "QualityParameter.hpp"

namespace NMM {

class Range : public NMM::SerializedValue {

    NMM::TValue<QualityParameter> _start;
    NMM::TValue<QualityParameter> _end;

    void registerValues();

  public:

    Range();
    Range(QualityParameter , QualityParameter );
    Range(const Range&);

    const Range reverse() {
      Range reverse_range(_end.getRValue(), _start.getRValue());
      return (reverse_range);
    }

    const QualityParameter start() const {
      return _start.getRValue();
    }

    const QualityParameter end() const {
      return _end.getRValue();
    }

    friend bool operator<(const Range& A, const Range& B) {
      return ((A._start.getRValue() < B._start.getRValue()) || ((A._start.getRValue() == B._start.getRValue()) && (A._end.getRValue() < B._end.getRValue())));
    }

    friend bool operator==(const Range& A, const Range& B) {
      return ((A._start.getRValue() == B._start.getRValue()) && (A._end.getRValue() == B._end.getRValue()));
    }

    Range*    copy()         const { return new Range(*this); }
    //Range&    operator=(const Range&);

};


}

#endif
