
#include "IMMBoxEventReceiver.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IMMBoxEventReceiver::receiveEventID(const string& id)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<string > id_value(id, false);
    Event event("IMMBoxEventReceiver::receiveEventID", &id_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IMMBoxEventReceiver::IMMBoxEventReceiver_type = "IMMBoxEventReceiver";
  TIFactoryObject<IMMBoxEventReceiver > __IMMBoxEventReceiver_prototype("IMMBoxEventReceiver");


  const char* IMMBoxEventReceiver::receiveEventID_event = "IMMBoxEventReceiver::receiveEventID";


}


