
#ifndef NMM_IAVMuxImpl_HPP
#define NMM_IAVMuxImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IAVMux.hpp"


namespace NMM
{
  /** Audio/video mux interface. */

  class IAVMuxImpl  : public virtual NMMObject { 
  public:
    IAVMuxImpl() { addInterface(new IAVMux(*this)); registerEvents(); };

    virtual ~IAVMuxImpl() {};

  protected:
    /**
     * Enable/disable synchronized mode.
     * Enables or disables synchronized mode.
     * In synchronized mode, buffers are sorted for increasing timestamps.
     * In normal mode, buffers are output in the order of arrival.
     * @param value true to enable synchronized mode
     */

    virtual void setSyncMode(const bool& value) = 0;


  private:
    void registerEvents();
  };

}

#endif
