
#ifndef NMM_ISetBufferLabel_HPP
#define NMM_ISetBufferLabel_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ISetBufferLabel : virtual public Interface { 
  public:
    ISetBufferLabel() {  setTypeInfo(TypeInfo(ISetBufferLabel::ISetBufferLabel_type, "NMM")); };

    ISetBufferLabel(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ISetBufferLabel::ISetBufferLabel_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISetBufferLabel() {};

    static const char* ISetBufferLabel_type;

    virtual  string getInterfaceType() const { return ISetBufferLabel_type; }

    Interface* copy() const { return new ISetBufferLabel(*this); }
    static const char* setBufferLabel_event;
    static Event* create_setBufferLabel(const string& stream, const int& label);
  /* instream (protected) and non-instream (public) */    
    virtual Result setBufferLabel(const string& stream, const int& label) /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<ISetBufferLabel> ISetBufferLabel_var;




}

#endif
