
#include "IBufferManager.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  NMMReference IBufferManager::getBufferManager()
      throw(const Exception&)
  {
    TOutValue<NMMReference > return_value;
    Event event("IBufferManager::getBufferManager");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IBufferManager::useBufferManager(const IBufferManager& manager)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<IBufferManager > manager_value(manager, false);
    Event event("IBufferManager::useBufferManager", &manager_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IBufferManager::releaseBufferManager()
      throw(const Exception&)
  {
    Event event("IBufferManager::releaseBufferManager");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IBufferManager::IBufferManager_type = "IBufferManager";
  TIFactoryObject<IBufferManager > __IBufferManager_prototype("IBufferManager");


  const char* IBufferManager::getBufferManager_event = "IBufferManager::getBufferManager";
  const char* IBufferManager::useBufferManager_event = "IBufferManager::useBufferManager";
  const char* IBufferManager::releaseBufferManager_event = "IBufferManager::releaseBufferManager";


}


