
#ifndef NMM_IBufferManager_HPP
#define NMM_IBufferManager_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IBufferManager : virtual public Interface { 
  public:
    IBufferManager() {  setTypeInfo(TypeInfo(IBufferManager::IBufferManager_type, "NMM")); };

    IBufferManager(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IBufferManager::IBufferManager_type, "NMM")); setEventReceiver(parent); };

    virtual ~IBufferManager() {};

    static const char* IBufferManager_type;

    virtual  string getInterfaceType() const { return IBufferManager_type; }

    Interface* copy() const { return new IBufferManager(*this); }
    static const char* getBufferManager_event;
    static const char* useBufferManager_event;
    static const char* releaseBufferManager_event;

    virtual NMMReference getBufferManager()
      throw(const Exception&);

    virtual Result useBufferManager(const IBufferManager& manager)
      throw(const Exception&);

    virtual void releaseBufferManager()
      throw(const Exception&);


  };

  typedef auto_ptr<IBufferManager> IBufferManager_var;




}

#endif
