
#include "INamed.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void INamed::setName(const string& value)
      throw(const Exception&)
  {
    TInValue<string > value_value(value, false);
    Event event("INamed::setName", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string INamed::getName() const
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("INamed::getName");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void INamed::setErrorStream(const string& filname, const int& debug_level)
      throw(const Exception&)
  {
    TInValue<string > filname_value(filname, false);
    TInValue<int > debug_level_value(debug_level, false);
    Event event("INamed::setErrorStream", &filname_value, &debug_level_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void INamed::setDebugStream(const string& filname, const int& debug_level)
      throw(const Exception&)
  {
    TInValue<string > filname_value(filname, false);
    TInValue<int > debug_level_value(debug_level, false);
    Event event("INamed::setDebugStream", &filname_value, &debug_level_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void INamed::setWarningStream(const string& filename, const int& debug_level)
      throw(const Exception&)
  {
    TInValue<string > filename_value(filename, false);
    TInValue<int > debug_level_value(debug_level, false);
    Event event("INamed::setWarningStream", &filename_value, &debug_level_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void INamed::setMessageStream(const string& feilname, const int& debug_level)
      throw(const Exception&)
  {
    TInValue<string > feilname_value(feilname, false);
    TInValue<int > debug_level_value(debug_level, false);
    Event event("INamed::setMessageStream", &feilname_value, &debug_level_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* INamed::INamed_type = "INamed";
  TIFactoryObject<INamed > __INamed_prototype("INamed");


  const char* INamed::setName_event = "INamed::setName";
  const char* INamed::getName_event = "INamed::getName";
  const char* INamed::setErrorStream_event = "INamed::setErrorStream";
  const char* INamed::setDebugStream_event = "INamed::setDebugStream";
  const char* INamed::setWarningStream_event = "INamed::setWarningStream";
  const char* INamed::setMessageStream_event = "INamed::setMessageStream";


}


