
#ifndef NMM_IReferenceCountImpl_HPP
#define NMM_IReferenceCountImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IReferenceCount.hpp"


namespace NMM
{

  class IReferenceCountImpl  : public virtual NMMObject { 
  public:
    IReferenceCountImpl() { addInterface(new IReferenceCount(*this)); registerEvents(); };

    virtual ~IReferenceCountImpl() {};

  protected:
    /**
     * Increases the ref count by i.
     */

    virtual void increaseCount(const unsigned int& i = 1) = 0;
    /**
     * Decreases the ref count by i.
     */

    virtual void decreaseCount(const unsigned int& i = 1) = 0;
    /**
     * Returns the current ref count.
     */

    virtual unsigned int getCount() = 0;


  private:
    void registerEvents();
  };

}

#endif
