
#ifndef NMM_IThreadedNode_HPP
#define NMM_IThreadedNode_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "INode.hpp"

namespace NMM
{

  class IThreadedNode : virtual public Interface { 
  public:
    IThreadedNode() {  setTypeInfo(TypeInfo(IThreadedNode::IThreadedNode_type, "NMM")); };

    IThreadedNode(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IThreadedNode::IThreadedNode_type, "NMM")); setEventReceiver(parent); };

    virtual ~IThreadedNode() {};

    static const char* IThreadedNode_type;

    virtual  string getInterfaceType() const { return IThreadedNode_type; }

    Interface* copy() const { return new IThreadedNode(*this); }
    static const char* lowerPriority_event;
    /**
     * Lower the thread priority by amount. The value must be between 1-20.
     */

    virtual void lowerPriority(const unsigned int& value) /* limited(INode::OUTPUT_INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */
      throw(const Exception&, const IllegalStateException&);


  };

  typedef auto_ptr<IThreadedNode> IThreadedNode_var;




}

#endif
