
#ifndef NMM_ITransportStrategy_HPP
#define NMM_ITransportStrategy_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ITransportStrategy : virtual public Interface { 
  public:
    ITransportStrategy() {  setTypeInfo(TypeInfo(ITransportStrategy::ITransportStrategy_type, "NMM")); };

    ITransportStrategy(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ITransportStrategy::ITransportStrategy_type, "NMM")); setEventReceiver(parent); };

    virtual ~ITransportStrategy() {};

    static const char* ITransportStrategy_type;

    virtual  string getInterfaceType() const { return ITransportStrategy_type; }

    Interface* copy() const { return new ITransportStrategy(*this); }
    static const char* setSendValueStream_event;
    static const char* setReceiveValueStream_event;
    static Event* create_setReceiveValueStream(const string& input_stream);

    virtual void setSendValueStream(const string& input_stream)
      throw(const Exception&);
  /* instream (protected) and non-instream (public) */        /*declared as instream */

    virtual void setReceiveValueStream(const string& input_stream) /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<ITransportStrategy> ITransportStrategy_var;




}

#endif
