
#ifndef NMM_IUsageNotify_HPP
#define NMM_IUsageNotify_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /**
   *This Interfaces notifies the user about status-change
   */

  class IUsageNotify : virtual public Interface { 
  public:
    IUsageNotify() {  setTypeInfo(TypeInfo(IUsageNotify::IUsageNotify_type, "NMM")); };

    IUsageNotify(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IUsageNotify::IUsageNotify_type, "NMM")); setEventReceiver(parent); };

    virtual ~IUsageNotify() {};

    static const char* IUsageNotify_type;

    virtual  string getInterfaceType() const { return IUsageNotify_type; }

    Interface* copy() const { return new IUsageNotify(*this); }
    static const char* becomeMaster_event;
    static const char* becomeSlave_event;
    /**
     *If this function is called by the Usage-class, the user is the new master of the node
     */

    virtual Result becomeMaster()
      throw(const Exception&);
    /**
     *If this function is called, the user has become slave on this node. This means, that an application with higher priority has requested the node
     */

    virtual Result becomeSlave()
      throw(const Exception&);


  };

  typedef auto_ptr<IUsageNotify> IUsageNotify_var;




}

#endif
