
#include "ISynchronized.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ISynchronized::setSynchronized(const bool& toggle) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<bool > toggle_value(toggle, false);
    Event event("ISynchronized::setSynchronized", &toggle_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ISynchronized::isSynchronized()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ISynchronized::isSynchronized");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISynchronized::ISynchronized_type = "ISynchronized";
  TIFactoryObject<ISynchronized > __ISynchronized_prototype("ISynchronized");


  const char* ISynchronized::setSynchronized_event = "ISynchronized::setSynchronized";
  Event* ISynchronized::create_setSynchronized(const bool& toggle)
  {
    TInValue<bool >* toggle_value = new TInValue<bool >();
    toggle_value->setValue(toggle);

    return new Event("ISynchronized::setSynchronized", toggle_value);
  }

  const char* ISynchronized::isSynchronized_event = "ISynchronized::isSynchronized";


}


