
#include "ISynchronizedSink.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  ISinkController* ISynchronizedSink::getController()
      throw(const Exception&)
  {
    TOutValue<ISinkController* > return_value;
    Event event("ISynchronizedSink::getController");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ISynchronizedSink::isBuffered() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ISynchronizedSink::isBuffered");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISynchronizedSink::ISynchronizedSink_type = "ISynchronizedSink";
  TIFactoryObject<ISynchronizedSink > __ISynchronizedSink_prototype("ISynchronizedSink");


  const char* ISynchronizedSink::getController_event = "ISynchronizedSink::getController";
  const char* ISynchronizedSink::isBuffered_event = "ISynchronizedSink::isBuffered";


}


