
#ifndef NMM_ISynchronizerImpl_HPP
#define NMM_ISynchronizerImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ISynchronizer.hpp"


namespace NMM
{

  class ISynchronizerImpl  : public virtual NMMObject { 
  public:
    ISynchronizerImpl() { addInterface(new ISynchronizer(*this)); registerEvents(); };

    virtual ~ISynchronizerImpl() {};

  protected:

    virtual Result pause() = 0;

    virtual Result wakeup() = 0;
   /**
     * Resets the Synchronizer.
     * This method is used by the sink controllers and should not be called 
     * directly.
     * Only internal variables are reset, you don't need to set the
     * audio and video sink after a reset call.
     * Switches the state from WORKING to RESET.
     * @param sink sink ID
     */

    virtual Result reset(const int& sink) = 0;


  private:
    void registerEvents();
  };

}

#endif
