
#include "ITimeshiftingImpl.hpp"


namespace NMM
{
  
  void ITimeshiftingImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(ITimeshifting::enableMemBuf_event, new TEDObject1<ITimeshiftingImpl, unsigned int, void(ITimeshiftingImpl:: * )(const unsigned int&), void >(this, &ITimeshiftingImpl::enableMemBuf));
  
    getEventDispatcher().registerEvent(ITimeshifting::disableMemBuf_event, new TEDObject1<ITimeshiftingImpl, bool, void(ITimeshiftingImpl:: * )(const bool&), void >(this, &ITimeshiftingImpl::disableMemBuf));
  
    getEventDispatcher().registerEvent(ITimeshifting::isMemBuf_event, new TEDObject0<ITimeshiftingImpl, bool(ITimeshiftingImpl:: * )(), bool >(this, &ITimeshiftingImpl::isMemBuf));
  
    getEventDispatcher().registerEvent(ITimeshifting::keepData_event, new TEDObject1<ITimeshiftingImpl, bool, void(ITimeshiftingImpl:: * )(const bool&), void >(this, &ITimeshiftingImpl::keepData));
  
    getEventDispatcher().registerEvent(ITimeshifting::getMode_event, new TEDObject0<ITimeshiftingImpl, ITimeshifting::Mode(ITimeshiftingImpl:: * )() const, ITimeshifting::Mode >(this, &ITimeshiftingImpl::getMode));
  
    getEventDispatcher().registerEvent(ITimeshifting::getPlayMode_event, new TEDObject0<ITimeshiftingImpl, ITimeshifting::PlayMode(ITimeshiftingImpl:: * )() const, ITimeshifting::PlayMode >(this, &ITimeshiftingImpl::getPlayMode));
  
    getEventDispatcher().registerEvent(ITimeshifting::setModeLive_event, new TEDObject2<ITimeshiftingImpl, bool, bool, void(ITimeshiftingImpl:: * )(const bool&, const bool&), void >(this, &ITimeshiftingImpl::setModeLive));
  
    getEventDispatcher().registerEvent(ITimeshifting::setModeFBLive_event, new TEDObject1<ITimeshiftingImpl, bool, void(ITimeshiftingImpl:: * )(const bool&), void >(this, &ITimeshiftingImpl::setModeFBLive));
  
    getEventDispatcher().registerEvent(ITimeshifting::setModePlay_event, new TEDObject1<ITimeshiftingImpl, bool, void(ITimeshiftingImpl:: * )(const bool&), void >(this, &ITimeshiftingImpl::setModePlay));
  
    getEventDispatcher().registerEvent(ITimeshifting::setModePause_event, new TEDObject0<ITimeshiftingImpl, void(ITimeshiftingImpl:: * )(), void >(this, &ITimeshiftingImpl::setModePause));
  
    getEventDispatcher().registerEvent(ITimeshifting::setModeFastForward_event, new TEDObject1<ITimeshiftingImpl, int, void(ITimeshiftingImpl:: * )(const int&), void >(this, &ITimeshiftingImpl::setModeFastForward));
  
    getEventDispatcher().registerEvent(ITimeshifting::setModeRewind_event, new TEDObject1<ITimeshiftingImpl, int, void(ITimeshiftingImpl:: * )(const int&), void >(this, &ITimeshiftingImpl::setModeRewind));
  
    getEventDispatcher().registerEvent(ITimeshifting::setFilename_event, new TEDObject1<ITimeshiftingImpl, string, void(ITimeshiftingImpl:: * )(const string&), void >(this, &ITimeshiftingImpl::setFilename));
  
    getEventDispatcher().registerEvent(ITimeshifting::setFileBufferThreshhold_event, new TEDObject1<ITimeshiftingImpl, unsigned int, void(ITimeshiftingImpl:: * )(const unsigned int&), void >(this, &ITimeshiftingImpl::setFileBufferThreshhold));
    getEventDispatcher().addLimited(ITimeshifting::setFileBufferThreshhold_event, INode::CONSTRUCTED);
  
    getEventDispatcher().registerEvent(ITimeshifting::setBufferSize_event, new TEDObject1<ITimeshiftingImpl, unsigned int, Result(ITimeshiftingImpl:: * )(const unsigned int&), Result >(this, &ITimeshiftingImpl::setBufferSize));
  
    getEventDispatcher().registerEvent(ITimeshifting::startRecord_event, new TEDObject0<ITimeshiftingImpl, void(ITimeshiftingImpl:: * )(), void >(this, &ITimeshiftingImpl::startRecord));
  
    getEventDispatcher().registerEvent(ITimeshifting::stopRecord_event, new TEDObject0<ITimeshiftingImpl, void(ITimeshiftingImpl:: * )(), void >(this, &ITimeshiftingImpl::stopRecord));
  
    getEventDispatcher().registerEvent(ITimeshifting::isRecording_event, new TEDObject0<ITimeshiftingImpl, bool(ITimeshiftingImpl:: * )(), bool >(this, &ITimeshiftingImpl::isRecording));
  
    getEventDispatcher().registerEvent(ITimeshifting::saveToFile_event, new TEDObject1<ITimeshiftingImpl, string, Result(ITimeshiftingImpl:: * )(const string&), Result >(this, &ITimeshiftingImpl::saveToFile));
  
    getEventDispatcher().registerEvent(ITimeshifting::getReadPosition_event, new TEDObject0<ITimeshiftingImpl, Time(ITimeshiftingImpl:: * )() const, Time >(this, &ITimeshiftingImpl::getReadPosition));
    getEventDispatcher().addLimited(ITimeshifting::getReadPosition_event, INode::STARTED);
  
    getEventDispatcher().registerEvent(ITimeshifting::getStartTime_event, new TEDObject0<ITimeshiftingImpl, Time(ITimeshiftingImpl:: * )() const, Time >(this, &ITimeshiftingImpl::getStartTime));
    getEventDispatcher().addLimited(ITimeshifting::getStartTime_event, INode::STARTED);
  
    getEventDispatcher().registerEvent(ITimeshifting::getLivePosition_event, new TEDObject0<ITimeshiftingImpl, Time(ITimeshiftingImpl:: * )() const, Time >(this, &ITimeshiftingImpl::getLivePosition));
    getEventDispatcher().addLimited(ITimeshifting::getLivePosition_event, INode::STARTED);
  
    getEventDispatcher().registerEvent(ITimeshifting::getLiveOffset_event, new TEDObject0<ITimeshiftingImpl, Interval(ITimeshiftingImpl:: * )() const, Interval >(this, &ITimeshiftingImpl::getLiveOffset));
    getEventDispatcher().addLimited(ITimeshifting::getLiveOffset_event, INode::STARTED);
  
    getEventDispatcher().registerEvent(ITimeshifting::getFileLength_event, new TEDObject0<ITimeshiftingImpl, Interval(ITimeshiftingImpl:: * )() const, Interval >(this, &ITimeshiftingImpl::getFileLength));
    getEventDispatcher().addLimited(ITimeshifting::getFileLength_event, INode::STARTED);

  }
  
  void ITimeshiftingListenerImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(ITimeshiftingListener::timeshiftingBegin_event, new TEDObject0<ITimeshiftingListenerImpl, Result(ITimeshiftingListenerImpl:: * )(), Result >(this, &ITimeshiftingListenerImpl::timeshiftingBegin));
  
    getEventDispatcher().registerEvent(ITimeshiftingListener::live_event, new TEDObject0<ITimeshiftingListenerImpl, Result(ITimeshiftingListenerImpl:: * )(), Result >(this, &ITimeshiftingListenerImpl::live));
  
    getEventDispatcher().registerEvent(ITimeshiftingListener::setProgress_event, new TEDObject1<ITimeshiftingListenerImpl, Time, Result(ITimeshiftingListenerImpl:: * )(const Time&), Result >(this, &ITimeshiftingListenerImpl::setProgress));

  }

}


