
#ifndef NMM_ITrack_HPP
#define NMM_ITrack_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ITrack : virtual public Interface { 
  public:
    ITrack() {  setTypeInfo(TypeInfo(ITrack::ITrack_type, "NMM")); };

    ITrack(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ITrack::ITrack_type, "NMM")); setEventReceiver(parent); };

    virtual ~ITrack() {};

    static const char* ITrack_type;

    virtual  string getInterfaceType() const { return ITrack_type; }

    Interface* copy() const { return new ITrack(*this); }
    static const char* startTrack_event;
    static Event* create_startTrack(const string& filename);
    static const char* endTrack_event;
    static Event* create_endTrack();
    static const char* finished_event;
    static Event* create_finished();
  /* instream (protected) and non-instream (public) */    
    virtual Result startTrack(const string& filename) /* in-stream */ 
      throw(const Exception&);
    
    virtual Result endTrack() /* in-stream */ 
      throw(const Exception&);
    
    virtual Result finished() /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<ITrack> ITrack_var;




}

#endif
