
#include "IGuid.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IGuid::setGuid(const u_int64_t& value)
      throw(const Exception&)
  {
    TInValue<u_int64_t > value_value(value, false);
    Event event("IGuid::setGuid", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  u_int64_t IGuid::getGuid() const
      throw(const Exception&)
  {
    TOutValue<u_int64_t > return_value;
    Event event("IGuid::getGuid");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IGuid::IGuid_type = "IGuid";
  TIFactoryObject<IGuid > __IGuid_prototype("IGuid");


  const char* IGuid::setGuid_event = "IGuid::setGuid";
  const char* IGuid::getGuid_event = "IGuid::getGuid";


}


