
#ifndef NMM_IGuid_HPP
#define NMM_IGuid_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IGuid : virtual public Interface { 
  public:
    IGuid() {  setTypeInfo(TypeInfo(IGuid::IGuid_type, "NMM")); };

    IGuid(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IGuid::IGuid_type, "NMM")); setEventReceiver(parent); };

    virtual ~IGuid() {};

    static const char* IGuid_type;

    virtual  string getInterfaceType() const { return IGuid_type; }

    Interface* copy() const { return new IGuid(*this); }
    static const char* setGuid_event;
    static const char* getGuid_event;

    virtual void setGuid(const u_int64_t& value)
      throw(const Exception&);

    virtual u_int64_t getGuid() const
      throw(const Exception&);


  };

  typedef auto_ptr<IGuid> IGuid_var;




}

#endif
