
#include "IProgress.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IProgress::sendProgressInformation(const bool& value)
      throw(const Exception&)
  {
    TInValue<bool > value_value(value, false);
    Event event("IProgress::sendProgressInformation", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IProgress::setProgressInterval(const int& buffers)
      throw(const Exception&)
  {
    TInValue<int > buffers_value(buffers, false);
    Event event("IProgress::setProgressInterval", &buffers_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IProgress::IProgress_type = "IProgress";
  TIFactoryObject<IProgress > __IProgress_prototype("IProgress");


  const char* IProgress::sendProgressInformation_event = "IProgress::sendProgressInformation";
  const char* IProgress::setProgressInterval_event = "IProgress::setProgressInterval";


}


