
#ifndef NMM_ITVGuideProducer_HPP
#define NMM_ITVGuideProducer_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/interfaces/misc/tvguide/ITVGuide.hpp"

namespace NMM
{

  class ITVGuideProducer : virtual public Interface { 
  public:
    ITVGuideProducer() {  setTypeInfo(TypeInfo(ITVGuideProducer::ITVGuideProducer_type, "NMM")); };

    ITVGuideProducer(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ITVGuideProducer::ITVGuideProducer_type, "NMM")); setEventReceiver(parent); };

    virtual ~ITVGuideProducer() {};

    static const char* ITVGuideProducer_type;

    virtual  string getInterfaceType() const { return ITVGuideProducer_type; }

    Interface* copy() const { return new ITVGuideProducer(*this); }
    static const char* registerTVGuideServer_event;
    /**
     * Registers the ITVGuide-Interface to add Program-Information to the database
     *\param itvg ITVGuide-Interface
     */

    virtual void registerTVGuideServer(const ITVGuide* itvg)
      throw(const Exception&);


  };

  typedef auto_ptr<ITVGuideProducer> ITVGuideProducer_var;




}

#endif
