
#include "ITVGuideUpdateFinished.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ITVGuideUpdateFinished::partiallyFinished()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ITVGuideUpdateFinished::partiallyFinished");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVGuideUpdateFinished::finished()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ITVGuideUpdateFinished::finished");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVGuideUpdateFinished::newChannel()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ITVGuideUpdateFinished::newChannel");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVGuideUpdateFinished::newShow(const string& channelID)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<string > channelID_value(channelID, false);
    Event event("ITVGuideUpdateFinished::newShow", &channelID_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVGuideUpdateFinished::informationUpdate()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ITVGuideUpdateFinished::informationUpdate");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ITVGuideUpdateFinished::ITVGuideUpdateFinished_type = "ITVGuideUpdateFinished";
  TIFactoryObject<ITVGuideUpdateFinished > __ITVGuideUpdateFinished_prototype("ITVGuideUpdateFinished");


  const char* ITVGuideUpdateFinished::partiallyFinished_event = "ITVGuideUpdateFinished::partiallyFinished";
  const char* ITVGuideUpdateFinished::finished_event = "ITVGuideUpdateFinished::finished";
  const char* ITVGuideUpdateFinished::newChannel_event = "ITVGuideUpdateFinished::newChannel";
  const char* ITVGuideUpdateFinished::newShow_event = "ITVGuideUpdateFinished::newShow";
  const char* ITVGuideUpdateFinished::informationUpdate_event = "ITVGuideUpdateFinished::informationUpdate";


}


