
#include "ITVTimerImpl.hpp"


namespace NMM
{
  
  void ITVTimerImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(ITVTimer::programTimer_event, new TEDObject1<ITVTimerImpl, TVTimerEntry, Result(ITVTimerImpl:: * )(const TVTimerEntry&), Result >(this, &ITVTimerImpl::programTimer));
  
    getEventDispatcher().registerEvent(ITVTimer::changeTimer_event, new TEDObject1<ITVTimerImpl, TVTimerEntry, Result(ITVTimerImpl:: * )(const TVTimerEntry&), Result >(this, &ITVTimerImpl::changeTimer));
  
    getEventDispatcher().registerEvent(ITVTimer::deleteTimer_event, new TEDObject2<ITVTimerImpl, int, string, Result(ITVTimerImpl:: * )(const int&, const string&), Result >(this, &ITVTimerImpl::deleteTimer));
  
    getEventDispatcher().registerEvent(ITVTimer::getTimers_event, new TEDObject2<ITVTimerImpl, string, string, list<TVTimerEntry > (ITVTimerImpl:: * )(const string&, const string&), list<TVTimerEntry >  >(this, &ITVTimerImpl::getTimers));
  
    getEventDispatcher().registerEvent(ITVTimer::getTimer_event, new TEDObject1<ITVTimerImpl, unsigned int, TVTimerEntry(ITVTimerImpl:: * )(const unsigned int&), TVTimerEntry >(this, &ITVTimerImpl::getTimer));
  
    getEventDispatcher().registerEvent(ITVTimer::getSleepingTimers_event, new TEDObject0<ITVTimerImpl, list<TVTimerEntry > (ITVTimerImpl:: * )(), list<TVTimerEntry >  >(this, &ITVTimerImpl::getSleepingTimers));
  
    getEventDispatcher().registerEvent(ITVTimer::getRecordingTimers_event, new TEDObject0<ITVTimerImpl, list<TVTimerEntry > (ITVTimerImpl:: * )(), list<TVTimerEntry >  >(this, &ITVTimerImpl::getRecordingTimers));
  
    getEventDispatcher().registerEvent(ITVTimer::getRecordedTimers_event, new TEDObject0<ITVTimerImpl, list<TVTimerEntry > (ITVTimerImpl:: * )(), list<TVTimerEntry >  >(this, &ITVTimerImpl::getRecordedTimers));
  
    getEventDispatcher().registerEvent(ITVTimer::getConflictTimers_event, new TEDObject0<ITVTimerImpl, list<TVTimerEntry > (ITVTimerImpl:: * )(), list<TVTimerEntry >  >(this, &ITVTimerImpl::getConflictTimers));
  
    getEventDispatcher().registerEvent(ITVTimer::getConflictsWithTimer_event, new TEDObject1<ITVTimerImpl, TVTimerEntry, list<TVTimerEntry > (ITVTimerImpl:: * )(const TVTimerEntry&), list<TVTimerEntry >  >(this, &ITVTimerImpl::getConflictsWithTimer));
  
    getEventDispatcher().registerEvent(ITVTimer::loadTimer_event, new TEDObject1<ITVTimerImpl, string, Result(ITVTimerImpl:: * )(const string&), Result >(this, &ITVTimerImpl::loadTimer));
  
    getEventDispatcher().registerEvent(ITVTimer::saveTimer_event, new TEDObject1<ITVTimerImpl, string, Result(ITVTimerImpl:: * )(const string&), Result >(this, &ITVTimerImpl::saveTimer));
  
    getEventDispatcher().registerEvent(ITVTimer::setTVGuide_event, new TEDObject1<ITVTimerImpl, ITVGuide*, void(ITVTimerImpl:: * )(const ITVGuide*), void >(this, &ITVTimerImpl::setTVGuide));
  
    getEventDispatcher().registerEvent(ITVTimer::getTVGuide_event, new TEDObject0<ITVTimerImpl, ITVGuide*(ITVTimerImpl:: * )(), ITVGuide* >(this, &ITVTimerImpl::getTVGuide));
  
    getEventDispatcher().registerEvent(ITVTimer::setDirectory_event, new TEDObject1<ITVTimerImpl, string, void(ITVTimerImpl:: * )(const string&), void >(this, &ITVTimerImpl::setDirectory));
  
    getEventDispatcher().registerEvent(ITVTimer::getDirectory_event, new TEDObject0<ITVTimerImpl, string(ITVTimerImpl:: * )(), string >(this, &ITVTimerImpl::getDirectory));
  
    getEventDispatcher().registerEvent(ITVTimer::getChannelConfig_event, new TEDObject0<ITVTimerImpl, TVChannelList(ITVTimerImpl:: * )(), TVChannelList >(this, &ITVTimerImpl::getChannelConfig));

  }

}


