
#ifndef NMM_IMethodCallImpl_HPP
#define NMM_IMethodCallImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IMethodCall.hpp"


namespace NMM
{
  /**
   * Interface with different method calls for performance tests
   */

  class IMethodCallImpl  : public virtual NMMObject { 
  public:
    IMethodCallImpl() { addInterface(new IMethodCall(*this)); registerEvents(); };

    virtual ~IMethodCallImpl() {};

  protected:

    virtual void noArgumentNoReturn() = 0;

    virtual int noArgumentIntReturn() = 0;

    virtual int oneArgumentInIntReturn(const int& value1) = 0;

    virtual int twoArgumentInIntReturn(const int& value1, const int& value2) = 0;

    virtual int threeArgumentInIntReturn(const int& value1, const int& value2, const int& value3) = 0;

    virtual int fourArgumentInIntReturn(const int& value1, const int& value2, const int& value3, const int& value4) = 0;

    virtual int fiveArgumentInIntReturn(const int& value1, const int& value2, const int& value3, const int& value4, const int& value5) = 0;

    virtual int oneArgumentOutIntReturn(int& value1) = 0;

    virtual int twoArgumentOutIntReturn(int& value1, int& value2) = 0;

    virtual int threeArgumentOutIntReturn(int& value1, int& value2, int& value3) = 0;

    virtual int fourArgumentOutIntReturn(int& value1, int& value2, int& value3, int& value4) = 0;

    virtual int fiveArgumentOutIntReturn(int& value1, int& value2, int& value3, int& value4, int& value5) = 0;

    virtual int oneArgumentInOutIntReturn(int& value1) = 0;

    virtual int twoArgumentInOutIntReturn(int& value1, int& value2) = 0;

    virtual int threeArgumentInOutIntReturn(int& value1, int& value2, int& value3) = 0;

    virtual int fourArgumentInOutIntReturn(int& value1, int& value2, int& value3, int& value4) = 0;

    virtual int fiveArgumentInOutIntReturn(int& value1, int& value2, int& value3, int& value4, int& value5) = 0;

    virtual void stringInArgument(const string& value1) = 0;

    virtual void stringOutArgument(string& value1) = 0;

    virtual void stringInOutArgument(string& value1) = 0;

    virtual int getMethodCallCounter() = 0;

    virtual void resetMethodCallCounter() = 0;


  private:
    void registerEvents();
  };

}

#endif
