
#ifndef NMM_ICrop_HPP
#define NMM_ICrop_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/interfaces/base/INode.hpp"

namespace NMM
{

  class ICrop : virtual public Interface { 
  public:
    ICrop() {  setTypeInfo(TypeInfo(ICrop::ICrop_type, "NMM")); };

    ICrop(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ICrop::ICrop_type, "NMM")); setEventReceiver(parent); };

    virtual ~ICrop() {};

    static const char* ICrop_type;

    virtual  string getInterfaceType() const { return ICrop_type; }

    Interface* copy() const { return new ICrop(*this); }
    static const char* setCrop_event;

    virtual void setCrop(const int& xOffset, const int& yOffset, const int& xRange, const int& yRange) /* required(INode::INITIALIZED, INode::OUTPUT_INITIALIZED) */ /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&);


  };

  typedef auto_ptr<ICrop> ICrop_var;




}

#endif
