
#ifndef NMM_IFrameCount_HPP
#define NMM_IFrameCount_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /**
   * Requesting of frame count.
   *
   * Defines a method that returns the frame count of some video stream.
   */

  class IFrameCount : virtual public Interface { 
  public:
    IFrameCount() {  setTypeInfo(TypeInfo(IFrameCount::IFrameCount_type, "NMM")); };

    IFrameCount(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IFrameCount::IFrameCount_type, "NMM")); setEventReceiver(parent); };

    virtual ~IFrameCount() {};

    static const char* IFrameCount_type;

    virtual  string getInterfaceType() const { return IFrameCount_type; }

    Interface* copy() const { return new IFrameCount(*this); }
    static const char* getFrameCount_event;
    /**
     * Get the framecount
     */

    virtual int getFrameCount() const
      throw(const Exception&);


  };

  typedef auto_ptr<IFrameCount> IFrameCount_var;




}

#endif
