
#ifndef NMM_IKeyframe_HPP
#define NMM_IKeyframe_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IKeyframe : virtual public Interface { 
  public:
    IKeyframe() {  setTypeInfo(TypeInfo(IKeyframe::IKeyframe_type, "NMM")); };

    IKeyframe(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IKeyframe::IKeyframe_type, "NMM")); setEventReceiver(parent); };

    virtual ~IKeyframe() {};

    static const char* IKeyframe_type;

    virtual  string getInterfaceType() const { return IKeyframe_type; }

    Interface* copy() const { return new IKeyframe(*this); }
    static const char* setKeyframe_event;
    static Event* create_setKeyframe();
  /* instream (protected) and non-instream (public) */    
    virtual Result setKeyframe() /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<IKeyframe> IKeyframe_var;




}

#endif
