
#include "IDisplayEventSender.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IDisplayEventSender::enableDisplayEvents(const string& config_file /* = "" */) /* limited(INode::STARTED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<string > config_file_value(config_file, false);
    Event event("IDisplayEventSender::enableDisplayEvents", &config_file_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IDisplayEventSender::disableDisplayEvents()
      throw(const Exception&)
  {
    Event event("IDisplayEventSender::disableDisplayEvents");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IDisplayEventSender::IDisplayEventSender_type = "IDisplayEventSender";
  TIFactoryObject<IDisplayEventSender > __IDisplayEventSender_prototype("IDisplayEventSender");


  const char* IDisplayEventSender::enableDisplayEvents_event = "IDisplayEventSender::enableDisplayEvents";
  const char* IDisplayEventSender::disableDisplayEvents_event = "IDisplayEventSender::disableDisplayEvents";


}


