
#ifndef NMM_IXWindowID_HPP
#define NMM_IXWindowID_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /**
   * Interface for requesting XID of a XWindow.
   */

  class IXWindowID : virtual public Interface { 
  public:
    IXWindowID() {  setTypeInfo(TypeInfo(IXWindowID::IXWindowID_type, "NMM")); };

    IXWindowID(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IXWindowID::IXWindowID_type, "NMM")); setEventReceiver(parent); };

    virtual ~IXWindowID() {};

    static const char* IXWindowID_type;

    virtual  string getInterfaceType() const { return IXWindowID_type; }

    Interface* copy() const { return new IXWindowID(*this); }
    static const char* getWindowID_event;
    /**
     * Request XID of a XWindow
     */

    virtual unsigned long getWindowID()
      throw(const Exception&);


  };

  typedef auto_ptr<IXWindowID> IXWindowID_var;




}

#endif
