
#ifndef NMM_IBrightness_HPP
#define NMM_IBrightness_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IBrightness : virtual public Interface { 
  public:
    IBrightness() {  setTypeInfo(TypeInfo(IBrightness::IBrightness_type, "NMM")); };

    IBrightness(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IBrightness::IBrightness_type, "NMM")); setEventReceiver(parent); };

    virtual ~IBrightness() {};

    static const char* IBrightness_type;

    virtual  string getInterfaceType() const { return IBrightness_type; }

    Interface* copy() const { return new IBrightness(*this); }
    static const char* setBrightness_event;

    virtual void setBrightness(const float& brightness)
      throw(const Exception&);


  };

  typedef auto_ptr<IBrightness> IBrightness_var;




}

#endif
