
#include "ILogoDisplay.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ILogoDisplay::setLogoImage(const string& path)
      throw(const Exception&)
  {
    TInValue<string > path_value(path, false);
    Event event("ILogoDisplay::setLogoImage", &path_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ILogoDisplay::ILogoDisplay_type = "ILogoDisplay";
  TIFactoryObject<ILogoDisplay > __ILogoDisplay_prototype("ILogoDisplay");


  const char* ILogoDisplay::setLogoImage_event = "ILogoDisplay::setLogoImage";


}


