
#ifndef NMM_ILogoDisplay_HPP
#define NMM_ILogoDisplay_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "ISetOffset.hpp"

namespace NMM
{

  class ILogoDisplay : virtual public ISetOffset { 
  public:
    ILogoDisplay() {  setTypeInfo(TypeInfo(ILogoDisplay::ILogoDisplay_type, "NMM")); };

    ILogoDisplay(NMMObject& parent) : ISetOffset(parent) {  setTypeInfo(TypeInfo(ILogoDisplay::ILogoDisplay_type, "NMM")); setEventReceiver(parent); };

    virtual ~ILogoDisplay() {};

    static const char* ILogoDisplay_type;

    virtual  string getInterfaceType() const { return ILogoDisplay_type; }

    Interface* copy() const { return new ILogoDisplay(*this); }
    static const char* setLogoImage_event;

    virtual void setLogoImage(const string& path)
      throw(const Exception&);


  };

  typedef auto_ptr<ILogoDisplay> ILogoDisplay_var;




}

#endif
