
#ifndef NMM_IOverlayImpl_HPP
#define NMM_IOverlayImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IOverlay.hpp"

#include "ISetOffsetImpl.hpp"

namespace NMM
{

  class IOverlayImpl  : virtual public ISetOffsetImpl { 
  public:
    IOverlayImpl() { addInterface(new IOverlay(*this)); registerEvents(); };

    virtual ~IOverlayImpl() {};

  protected:

    virtual void setAlpha(const float& alpha) = 0;

    virtual float getAlpha() const = 0;
    /**
     * Set dimension and start coordinates of foreground image.
     * @param x x-position of upper left corner
     * @param y y-position of upper left corner
     * @param w width of foreground image
     * @param h height of foreground image
     */

    virtual void setForeground(const int& x, const int& y, const int& w, const int& h) = 0;

    virtual void setForegroundSegment(const int& x, const int& y, const int& w, const int& h) = 0;

    virtual Result disableOverlay() /* in-stream */  = 0;


  private:
    void registerEvents();
  };

}

#endif
