
#include "ISetOffset.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ISetOffset::setOffset(const int& x, const int& y)
      throw(const Exception&)
  {
    TInValue<int > x_value(x, false);
    TInValue<int > y_value(y, false);
    Event event("ISetOffset::setOffset", &x_value, &y_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ISetOffset::getOffset(int& x, int& y) const
      throw(const Exception&)
  {
    TOutValue<int > x_value(x);
    TOutValue<int > y_value(y);
    Event event("ISetOffset::getOffset", &x_value, &y_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    x = x_value.getRValue();
    y = y_value.getRValue();
  }

  const char* ISetOffset::ISetOffset_type = "ISetOffset";
  TIFactoryObject<ISetOffset > __ISetOffset_prototype("ISetOffset");


  const char* ISetOffset::setOffset_event = "ISetOffset::setOffset";
  const char* ISetOffset::getOffset_event = "ISetOffset::getOffset";


}


