
#include "IOSD.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IOSD::setText(const string& text)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<string > text_value(text, false);
    Event event("IOSD::setText", &text_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IOSD::IOSD_type = "IOSD";
  TIFactoryObject<IOSD > __IOSD_prototype("IOSD");


  const char* IOSD::setText_event = "IOSD::setText";


}


