
#ifndef NMM_IOSD_HPP
#define NMM_IOSD_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IOSDSetFont.hpp"

namespace NMM
{

  class IOSD : virtual public IOSDSetFont { 
  public:
    IOSD() {  setTypeInfo(TypeInfo(IOSD::IOSD_type, "NMM")); };

    IOSD(NMMObject& parent) : IOSDSetFont(parent) {  setTypeInfo(TypeInfo(IOSD::IOSD_type, "NMM")); setEventReceiver(parent); };

    virtual ~IOSD() {};

    static const char* IOSD_type;

    virtual  string getInterfaceType() const { return IOSD_type; }

    Interface* copy() const { return new IOSD(*this); }
    static const char* setText_event;

    virtual Result setText(const string& text)
      throw(const Exception&);


  };

  typedef auto_ptr<IOSD> IOSD_var;




}

#endif
