
#ifndef NMM_IImageViewImpl_HPP
#define NMM_IImageViewImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IImageView.hpp"

#include "IWidgetImpl.hpp"

namespace NMM
{
  /**
   * Image view widget interface.
   */

  class IImageViewImpl  : virtual public IWidgetImpl { 
  public:
    IImageViewImpl() { addInterface(new IImageView(*this)); registerEvents(); };

    virtual ~IImageViewImpl() {};

  protected:
    /**
     * Set bitmap identifier.
     * Set identifier of bitmap that should be drawn.
     * @param id bitmap identifier
     */

    virtual void setBitmapID(const string& id) = 0;


  private:
    void registerEvents();
  };

}

#endif
