
#ifndef NMM_IPlaneDecoratorImpl_HPP
#define NMM_IPlaneDecoratorImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IPlaneDecorator.hpp"

#include "IDecoratorImpl.hpp"

namespace NMM
{
  /**
   * Plane decorator interface.
   */

  class IPlaneDecoratorImpl  : virtual public IDecoratorImpl { 
  public:
    IPlaneDecoratorImpl() { addInterface(new IPlaneDecorator(*this)); registerEvents(); };

    virtual ~IPlaneDecoratorImpl() {};

  protected:
    /**
     * Set plane color.
     * @param color 32 bit border color (rgba format)
     */

    virtual void setPlaneColor(const u_int32_t& color) = 0;


  private:
    void registerEvents();
  };

}

#endif
