
#include "IProgressBar.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IProgressBar::setMaxProgress(const u_int64_t& value)
      throw(const Exception&)
  {
    TInValue<u_int64_t > value_value(value, false);
    Event event("IProgressBar::setMaxProgress", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IProgressBar::setProgress(const u_int64_t& value)
      throw(const Exception&)
  {
    TInValue<u_int64_t > value_value(value, false);
    Event event("IProgressBar::setProgress", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IProgressBar::setBarColor(const u_int32_t& value)
      throw(const Exception&)
  {
    TInValue<u_int32_t > value_value(value, false);
    Event event("IProgressBar::setBarColor", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IProgressBar::setBarSpaces(const unsigned int& space, const unsigned int& space_step)
      throw(const Exception&)
  {
    TInValue<unsigned int > space_value(space, false);
    TInValue<unsigned int > space_step_value(space_step, false);
    Event event("IProgressBar::setBarSpaces", &space_value, &space_step_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IProgressBar::IProgressBar_type = "IProgressBar";
  TIFactoryObject<IProgressBar > __IProgressBar_prototype("IProgressBar");


  const char* IProgressBar::setMaxProgress_event = "IProgressBar::setMaxProgress";
  const char* IProgressBar::setProgress_event = "IProgressBar::setProgress";
  const char* IProgressBar::setBarColor_event = "IProgressBar::setBarColor";
  const char* IProgressBar::setBarSpaces_event = "IProgressBar::setBarSpaces";


}


