
#include "IIVTVImpl.hpp"


namespace NMM
{
  
  void IIVTVImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(IIVTV::getCodecParams_event, new TEDObject0<IIVTVImpl, IVTVCodec(IIVTVImpl:: * )() const, IVTVCodec >(this, &IIVTVImpl::getCodecParams));
    getEventDispatcher().addLimited(IIVTV::getCodecParams_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::getCodecParams_event, INode::ACTIVATED);
    getEventDispatcher().addLimited(IIVTV::getCodecParams_event, INode::STARTED);
    getEventDispatcher().addLimited(IIVTV::getCodecParams_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setCodecParams_event, new TEDObject1<IIVTVImpl, IVTVCodec, void(IIVTVImpl:: * )(const IVTVCodec&), void >(this, &IIVTVImpl::setCodecParams));
    getEventDispatcher().addLimited(IIVTV::setCodecParams_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setCodecParams_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setGOPSize_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setGOPSize));
    getEventDispatcher().addLimited(IIVTV::setGOPSize_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setGOPSize_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setBFrames_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setBFrames));
    getEventDispatcher().addLimited(IIVTV::setBFrames_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setBFrames_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setGOPClosure_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setGOPClosure));
    getEventDispatcher().addLimited(IIVTV::setGOPClosure_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setGOPClosure_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setPulldown_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setPulldown));
    getEventDispatcher().addLimited(IIVTV::setPulldown_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setPulldown_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setBitrate_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setBitrate));
    getEventDispatcher().addLimited(IIVTV::setBitrate_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setBitrate_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setPeakBitrate_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setPeakBitrate));
    getEventDispatcher().addLimited(IIVTV::setPeakBitrate_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setPeakBitrate_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setStreamType_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setStreamType));
    getEventDispatcher().addLimited(IIVTV::setStreamType_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setStreamType_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setBitrateMode_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setBitrateMode));
    getEventDispatcher().addLimited(IIVTV::setBitrateMode_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setBitrateMode_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setDNRMode_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setDNRMode));
    getEventDispatcher().addLimited(IIVTV::setDNRMode_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setDNRMode_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setDNRType_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setDNRType));
    getEventDispatcher().addLimited(IIVTV::setDNRType_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setDNRType_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setDNRSpatial_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setDNRSpatial));
    getEventDispatcher().addLimited(IIVTV::setDNRSpatial_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setDNRSpatial_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setDNRTemporal_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setDNRTemporal));
    getEventDispatcher().addLimited(IIVTV::setDNRTemporal_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setDNRTemporal_event, INode::OUTPUT_INITIALIZED);
  
    getEventDispatcher().registerEvent(IIVTV::setAspect_event, new TEDObject1<IIVTVImpl, unsigned int, void(IIVTVImpl:: * )(const unsigned int&), void >(this, &IIVTVImpl::setAspect));
    getEventDispatcher().addLimited(IIVTV::setAspect_event, INode::INITIALIZED);
    getEventDispatcher().addLimited(IIVTV::setAspect_event, INode::OUTPUT_INITIALIZED);

  }

}


