
#ifndef NMM_ITVCard_HPP
#define NMM_ITVCard_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/interfaces/base/INode.hpp"
#include "nmm/interfaces/device/IDevice.hpp"

namespace NMM
{

  class ITVCard : virtual public IDevice { 
  public:
    ITVCard() {  setTypeInfo(TypeInfo(ITVCard::ITVCard_type, "NMM")); };

    ITVCard(NMMObject& parent) : IDevice(parent) {  setTypeInfo(TypeInfo(ITVCard::ITVCard_type, "NMM")); setEventReceiver(parent); };

    virtual ~ITVCard() {};

    static const char* ITVCard_type;

    virtual  string getInterfaceType() const { return ITVCard_type; }

    Interface* copy() const { return new ITVCard(*this); }
    static const char* setResolution_event;
    static const char* getResolution_event;
    static const char* setChannel_event;
    static const char* getChannel_event;

    virtual void setResolution(const int& x, const int& y) /* limited(INode::CONSTRUCTED) */ /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&);

    virtual void getResolution(int& x, int& y)
      throw(const Exception&);

    virtual Result setChannel(const int& channel) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&);

    virtual Result getChannel(int& c1, string& c2)
      throw(const Exception&);


  };

  typedef auto_ptr<ITVCard> ITVCard_var;




}

#endif
