
#ifndef NMM_ITVCardImpl_HPP
#define NMM_ITVCardImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ITVCard.hpp"

#include "nmm/interfaces/base/INodeImpl.hpp"
#include "nmm/interfaces/device/IDeviceImpl.hpp"

namespace NMM
{

  class ITVCardImpl  : virtual public IDeviceImpl { 
  public:
    ITVCardImpl() { addInterface(new ITVCard(*this)); registerEvents(); };

    virtual ~ITVCardImpl() {};

  protected:

    virtual void setResolution(const int& x, const int& y) /* limited(INode::CONSTRUCTED) */ /* limited(INode::INITIALIZED) */ = 0;

    virtual void getResolution(int& x, int& y) = 0;

    virtual Result setChannel(const int& channel) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */ = 0;

    virtual Result getChannel(int& c1, string& c2) = 0;


  private:
    void registerEvents();
  };

}

#endif
