/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Florian Winter <fw@graphics.cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 
 * USA.
 */

#ifndef _NMM_CONSOLEPRODUCER_HPP_
#define _NMM_CONSOLEPRODUCER_HPP_ _NMM_CONSOLEPRODUCER_HPP_

#include "nmm/base/GenericProducer.hpp"

#include <termios.h>

namespace NMM {

  class ConsoleProducer :
    public InputProducer
  {
  private:
    bool initialized;
    struct termios savetty;
    
    vector<string> keymap;
    
    Result initTTY();
    Result deinitTTY();
    
    void addKey(unsigned int key, string value);
    string getKeyMapping(unsigned int key);
    
  public:
    ConsoleProducer();
    ~ConsoleProducer();
    
    /** Init TTY and start event handling */
    void start();
    
    /** Stop event handling and exit TTY */
    void stop();
    
    /** Read configuration file */
    Result readConfig(string fname);
    
  protected:
    virtual void handleInput();
  };
  
}

#endif /* _NMM_CONSOLEPRODUCER_HPP_ */
