/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_LIRCEVENTS_HPP_
#define _NMM_LIRCEVENTS_HPP_

#include <lirc/lirc_client.h>


#include "nmm/base/GenericProducer.hpp"

namespace NMM {
  
  class LircProducer
    : public InputProducer {
    
  private:
    struct lirc_config* config;
    int lirc_fd;
    bool send_extended_events;
    
    /**
     * The event-handling function
     * Events can be received by all registered input-devices
     * (like X-Display, Console, mouse, ...)
    */
    void handleInput();
    
  public:
    LircProducer();
    ~LircProducer();
    
    /**
     * Reads a LIRC-configuration file.
     * In the configuration file are informations how key presses
     * will be mapped to the corresponding event-strings
     */
    bool readConfig(string);
    
    /**
     * Sets the flag to decide whether to send an extended event
     */
    void setSendExtendedEvents(bool);
    
    /**
     * Gets the flag to decide whether to send an extended event
     */
    bool getSendExtendedEvents();
  };

}

#endif
