/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef _NMM_PNGUTILS_HPP_
#define _NMM_PNGUTILS_HPP_ _NMM_PNGUTILS_HPP_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <png.h>
#include <sstream>

using namespace std;

namespace NMM {
  class PNGUtils {
  public:

    PNGUtils();
    ~PNGUtils();

    enum colorformat {RGBX32, RGB24, YV12, YV12A};
    void setFormat( colorformat );
    void setDimension( unsigned int width, unsigned int heigt );
    void writeImage( const string& filename, unsigned char* image );

  private:
    colorformat format;
    unsigned int width;
    unsigned int height;
    unsigned char* rgb_buffer;

    void destroyRGBBuffer();
    void writePNG(const string& file_name, unsigned char* image, unsigned int width, unsigned int height);

  };

}

#endif
