/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Christoph Wellner <chwellner@graphics.cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef TVCARDSEARCH_HPP
#define TVCARDSEARCH_HPP TVCARDSEARCH_HPP

#include "nmm/base/ProxyApplication.hpp"
#include "nmm/misc/tvtimer/TVTimerEntry.hpp"
#include "nmm/misc/tvtimer/TVTimerExceptions.hpp"

namespace NMM{

  typedef list < pair<int, TVCardDescription > > channelMap_t;
  
  class TVCardSearch{
  private:
    map<string , channelMap_t > tvcards;
    NMMApplication *app;

    list<TVCardDescription> tvcardhosts;

  public:
    TVCardSearch();
    ~TVCardSearch();

    TVCardDescription searchNewTVCard(string channelName, int &channelNumber) throw (NoCardFoundException);
    channelMap_t getCards(string channelName);

    void setApplication(NMMApplication *a){app = a;}

    Result validateHost(TVCardDescription card);

    void addHost(const NodeDescription &nd);
  private:
    void requestHosts(list<TVCardDescription> &l);
  };
}

#endif
