/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        NMM work group,
 *                    http://www.networkmultimedia.org
 *                     
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */



#ifndef NMM_SINKNETNODE_HPP
#define NMM_SINKNETNODE_HPP

#include "nmm/base/GenericSinkNode.hpp"

#include "nmm/utils/net/INetAddr.hpp"
#include "nmm/utils/net/Sock.hpp"
#include "nmm/utils/net/SockAcceptor.hpp"

namespace NMM {
/**
   
  */

class SlaveServerNode : public GenericSinkNode {
public: 
  //  SlaveServerNode(const char* name);
  SlaveServerNode(const char* name,
              const StreamQueue::Mode queue_mode = StreamQueue::DEFAULT_MODE,
              const int size = StreamQueue::DEFAULT_SIZE);

  virtual ~SlaveServerNode();

  Result setSocket(int& );
  Result setSock(Sock* );
  Result getConnections(unsigned int& );
  Result getHostName(string& );
protected:
  virtual Buffer* processBuffer(Buffer* buffer);

  virtual Result doDeactivate();
  virtual Result doInit();
  virtual Result doActivate();

private:
  bool is_connected;
  string local_host;
  Sock* sock;

  ThreadMutex socket_mutex;
};

} //end namepsace
#endif
