/* NMM - Network-Integrated Multimedia Environment
 *
 * Copyright (C) 2002 Network-Multimedia Workgroup,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Markus Sand <msand@graphics.cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_YV12_DEINTERLACE_H_
#define _NMM_YV12_DEINTERLACE_H_ _NMM_YV12_DEINTERLACE_H_

#ifdef __cplusplus
extern "C" {
#endif

  /**
  * deinterlaces an interlaced yv12 picture by using the average method (the average from
  * line 2n+1 and line 2n+3 is written to line 2n+2, n = 0,..., height/2 - 1, last line
  * is copied).
  * \param image pointer to the source bitmap
  * \param width width or number of pixels to get into a new line of the source bitmap
  * \param height height of the source bitmap
  */
  void yv12_deinterlace(char *image, unsigned int width, unsigned int height);

#ifdef __cplusplus
}
#endif

#endif // _NMM_YV12_DEINTERLACE_H_
