/* 
   RTjpeg (C) Justin Schoeman 1998 (justin@suntiger.ee.up.ac.za)
   
   With modifications by:
   (c) 1998, 1999 by Joerg Walter <trouble@moes.pmnet.uni-oldenburg.de>
   and
   (c) 1999 by Wim Taymans <wim.taymans@tvd.be>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    
*/

/* 
The code was changed by Marco Lohse <mlohse@cs.uni-sb.de> to support multi-threading
*/

#ifndef _RTJPEG_H
#define _RTJPEG_H


// #include <asm/types.h>


//#ifndef _I386_TYPES_H
typedef unsigned char  __rtjpeg__u8;
typedef unsigned short __rtjpeg__u16;
typedef unsigned long __rtjpeg__u32;
typedef u_int64_t   __rtjpeg__u64;
typedef signed char __rtjpeg__s8;
typedef signed short __rtjpeg__s16;
typedef signed long __rtjpeg__s32;
//#endif

#ifdef MMX
#include "mmx.h"
#endif


struct RTjpeg_struct {
#ifndef MMX
 __rtjpeg__s32 RTjpeg_ws[64+31];
#endif
__rtjpeg__u8 RTjpeg_alldata[2*64+4*64+4*64+4*64+4*64+32];


__rtjpeg__s16 *RTjpeg_block;
__rtjpeg__s32 *RTjpeg_lqt;
__rtjpeg__s32 *RTjpeg_cqt;
__rtjpeg__u32 *RTjpeg_liqt;
__rtjpeg__u32 *RTjpeg_ciqt;

__rtjpeg__u8 RTjpeg_lb8;
__rtjpeg__u8 RTjpeg_cb8;
int RTjpeg_width, RTjpeg_height;
int RTjpeg_Ywidth, RTjpeg_Cwidth;
int RTjpeg_Ysize, RTjpeg_Csize;

__rtjpeg__s16 *RTjpeg_old; //=NULL;

#ifdef MMX
mmx_t RTjpeg_lmask;
mmx_t RTjpeg_cmask;
#else
__rtjpeg__u16 RTjpeg_lmask;
__rtjpeg__u16 RTjpeg_cmask;
#endif
int RTjpeg_mtest; //=0;
};


void RTjpeg_init_Q(__rtjpeg__u8 Q, struct RTjpeg_struct *myStruct);

void RTjpeg_init_compress(long unsigned int *buf, int width, int height, __rtjpeg__u8 Q, struct RTjpeg_struct *myStruct);

void RTjpeg_init_decompress(long unsigned int *buf, int width, int height, struct RTjpeg_struct *myStruct );

int RTjpeg_compressYUV420(__rtjpeg__s8 *sp, __rtjpeg__u8 *bp, struct RTjpeg_struct *myStruct);
int RTjpeg_compressYUV422(__rtjpeg__s8 *sp, __rtjpeg__u8 *bp, struct RTjpeg_struct *myStruct);
void RTjpeg_decompressYUV420(__rtjpeg__s8 *sp, __rtjpeg__u8 *bp, struct RTjpeg_struct *myStruct);
void RTjpeg_decompressYUV422(__rtjpeg__s8 *sp, __rtjpeg__u8 *bp, struct RTjpeg_struct *myStruct);
int RTjpeg_compress8(__rtjpeg__s8 *sp, __rtjpeg__u8 *bp, struct RTjpeg_struct *myStruct);
void RTjpeg_decompress8(__rtjpeg__s8 *sp, __rtjpeg__u8 *bp, struct RTjpeg_struct *myStruct);

void RTjpeg_init_mcompress(struct RTjpeg_struct *myStruct);
int RTjpeg_mcompressYUV420(__rtjpeg__s8 *sp, __rtjpeg__u8 *bp, __rtjpeg__u16 lmask, __rtjpeg__u16 cmask, struct RTjpeg_struct *myStruct);
int RTjpeg_mcompressYUV422(__rtjpeg__s8 *sp, __rtjpeg__u8 *bp, __rtjpeg__u16 lmask, __rtjpeg__u16 cmask, struct RTjpeg_struct *myStruct);
int RTjpeg_mcompress8(__rtjpeg__s8 *sp, __rtjpeg__u8 *bp, __rtjpeg__u16 lmask, struct RTjpeg_struct *myStruct);
void RTjpeg_set_test(int i, struct RTjpeg_struct *myStruct);

void RTjpeg_yuv420rgb(__rtjpeg__u8 *buf, __rtjpeg__u8 *rgb, int stride, struct RTjpeg_struct *myStruct);
void RTjpeg_yuv422rgb(__rtjpeg__u8 *buf, __rtjpeg__u8 *rgb, int stride, struct RTjpeg_struct *myStruct );
void RTjpeg_yuvrgb8(__rtjpeg__u8 *buf, __rtjpeg__u8 *rgb, int stride, struct RTjpeg_struct *myStruct);
void RTjpeg_yuvrgb16(__rtjpeg__u8 *buf, __rtjpeg__u8 *rgb, int stride, struct RTjpeg_struct *myStruct);
void RTjpeg_yuvrgb24(__rtjpeg__u8 *buf, __rtjpeg__u8 *rgb, int stride, struct RTjpeg_struct *myStruct);
void RTjpeg_yuvrgb32(__rtjpeg__u8 *buf, __rtjpeg__u8 *rgb, int stride, struct RTjpeg_struct *myStruct);
		  

#endif
