/*
 * the following code was taken from mplayer and
 * slightly modified because just mmx-detection is
 * needed here.
 *
 * MPlayer is under the GNU General Public License
 */


#include "config.h"

namespace NMM {
#ifdef ARCH_X86
  static inline void do_cpuid(unsigned int ax, unsigned int *p)
  {
    // code from libavcodec:
    __asm __volatile
      ("movl %%ebx, %%esi\n\t"
       "cpuid\n\t"
       "xchgl %%ebx, %%esi"
       : "=a" (p[0]), "=S" (p[1]), 
       "=c" (p[2]), "=d" (p[3])
       : "0" (ax));
    
  }
#endif

  static inline bool hasMMX() {
    //inline assembler doesn't work on non X86 computers
#ifndef ARCH_X86
    return false;
#else

    unsigned int regs[4];
    unsigned int regs2[4];
    do_cpuid(0x00000000, regs); // get _max_ cpuid level and vendor name
    
    bool hasTSC,hasMMX,hasSSE,hasSSE2,hasMMX2;
    hasMMX=false;
    if (regs[0]>=0x00000001)
      {
        do_cpuid(0x00000001, regs2);
        
        // general feature flags:
        hasTSC  = (regs2[3] & (1 << 8  )) >>  8; // 0x0000010
        hasMMX  = (regs2[3] & (1 << 23 )) >> 23; // 0x0800000
        hasSSE  = (regs2[3] & (1 << 25 )) >> 25; // 0x2000000
        hasSSE2 = (regs2[3] & (1 << 26 )) >> 26; // 0x4000000
        hasMMX2 = hasSSE; // SSE cpus supports mmxext too
      }
    return hasMMX;
    #endif
  }
}
